#!/usr/bin/perl
use strict;

open(PO, "<$ARGV[1]") || die "$!";

my $rs = $/;
my %po;
my ($msgid, $msgstr);

$/="\n\n";

while (<PO>) {
	next unless /#: rh-entity/s;
	($msgid, $msgstr) = /msgid \"(.*?)\"\nmsgstr \"(.*?)\"\n/;
	$po{$msgid} = $msgstr;
}

close (PO);

$/ = $rs;

open(XML, "<$ARGV[0]") || die "$!";

while (<XML>) {
	my $line = $_;
	if ( /\<\!\s*ENTITY/ ) {
		foreach $msgid (keys %po) {
			next unless $msgstr = $po{$msgid};
			last if $line =~ s/$msgid/$msgstr/;
		}
	}
	print $line;
}

close(XML);
